SystemOrganization addCategory: #'ElasticSearch-Core'!
SystemOrganization addCategory: #'ElasticSearch-Core-QueryDSL'!

!DateAndTime methodsFor: '*elasticsearch-core' stamp: 'PaulDeBruicker 4/29/2013 16:07'!
jsonWriteOn: aStream
	aStream nextPut: $".
	self printOn: aStream.
	aStream nextPut: $"! !

!ZnClient methodsFor: '*elasticsearch-core' stamp: 'PaulDeBruicker 4/29/2013 16:13'!
get: url contents: object
	"Execute an HTTP GET request on url with the contents in a body and return the response #contents."

	^ self
		url: url;
		method: #GET;
		contents: object;
		execute! !

!ZnClient methodsFor: '*elasticsearch-core' stamp: 'PaulDeBruicker 4/29/2013 16:12'!
headResponseStatusFor: aUrl
	"Execute an HTTP GET request on url with the contents in a body and return the response #contents."

	self
		url: aUrl;
		method: #HEAD;
		execute.
	^ self response code! !

Object subclass: #ESAnalyzer
	instanceVariableNames: 'name modifiers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 15:57'!
asJsonString
	| d1 |
	d1 := Dictionary new.
	d1 at: 'type' put: self type.
	self modifiers keysAndValuesDo: [ :key :val | d1 at: key put: val ].
	^ (self name -> d1) ! !

!ESAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:24'!
initialize
	super initialize.
	modifiers := Dictionary new! !

!ESAnalyzer methodsFor: 'json' stamp: 'PaulDeBruicker 5/6/2013 16:44'!
jsonContent
	| d1 |
	d1 := self modifiers copy.
	d1 at: 'type' put: self type.
	^ d1! !

!ESAnalyzer methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 15:43'!
modifiers
	^ modifiers! !

!ESAnalyzer methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 15:43'!
modifiers: anObject
	modifiers := anObject! !

!ESAnalyzer methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 13:23'!
name
	^ name! !

!ESAnalyzer methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 13:23'!
name: anObject
	name := anObject! !

!ESAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:15'!
stopwords: anArrayOfWords
	self modifiers at: 'stopwords' put: anArrayOfWords! !

!ESAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:20'!
type
	self subclassResponsibility! !

ESAnalyzer subclass: #ESCharFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

ESCharFilter subclass: #ESHtmlStripCharFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESHtmlStripCharFilter methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:34'!
type
	^ 'html_strip'! !

ESAnalyzer subclass: #ESCustomAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESCustomAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:21'!
charFilter: anESCharFilter
	self modifiers at: 'char_filter' put: anESCharFilter! !

!ESCustomAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:21'!
filter: anESFilter
	self modifiers at: 'filter' put: anESFilter! !

!ESCustomAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:21'!
tokenizer: anESTokenizer
	self modifiers at: 'tokenizer' put: anESTokenizer! !

!ESCustomAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:20'!
type
	^ 'custom'! !

ESAnalyzer subclass: #ESKeywordAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESKeywordAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:20'!
type
	^ 'keyword'! !

ESAnalyzer subclass: #ESPatternAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESPatternAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:17'!
flags: aRegexFlags
	self modifiers at: 'flags' put: aRegexFlags! !

!ESPatternAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:16'!
lowercase: aBoolean
	self modifiers at: 'lowercase' put: aBoolean! !

!ESPatternAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:17'!
pattern: aRegex
	self modifiers at: 'pattern' put: aRegex! !

!ESPatternAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:20'!
type
	^ 'pattern'! !

ESAnalyzer subclass: #ESSimpleAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESSimpleAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:20'!
type
	^ 'simple'! !

ESAnalyzer subclass: #ESStandardAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESStandardAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:13'!
maxTokenLength: aNumber
	self modifiers at: 'max_token_length' put: aNumber! !

!ESStandardAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:20'!
type
	^ 'standard'! !

ESAnalyzer subclass: #ESStopAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESStopAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:15'!
stopwordsPath: aPathString
	self modifiers at: 'stopwords_path' put: aPathString! !

!ESStopAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:20'!
type
	^ 'stop'! !

ESAnalyzer subclass: #ESTokenFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

ESTokenFilter subclass: #ESNGramTokenFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

ESNGramTokenFilter subclass: #ESEdgeNGramTokenFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESEdgeNGramTokenFilter methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/9/2013 07:47'!
initialize
	super initialize.
	self side: 'front'! !

!ESEdgeNGramTokenFilter methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/9/2013 07:47'!
side: aSide
	self modifiers at: 'side' put: aSide! !

!ESNGramTokenFilter methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:32'!
maxGram: aNumber
	self modifiers at: 'max_gram' put: aNumber! !

!ESNGramTokenFilter methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:32'!
minGram: aNumber
	self modifiers at: 'min_gram' put: aNumber! !

!ESNGramTokenFilter methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:32'!
type
	^ 'nGram'! !

ESAnalyzer subclass: #ESTokenizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

ESTokenizer subclass: #ESWhitespaceTokenizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESWhitespaceTokenizer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:30'!
type
	^ 'whitespace'! !

ESAnalyzer subclass: #ESWhitespaceAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESWhitespaceAnalyzer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:20'!
type
	^ 'whitespace'! !

Object subclass: #ESDocumentId
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESDocumentId commentStamp: 'PaulDeBruicker 4/24/2013 10:13' prior: 0!
Used to create "unique" ids for documents.  Elasticsearch will do it automatically if you leave the id field blank when indexing a document!

!ESDocumentId class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 14:54'!
defaultIdStrategy
	^ ESDocumentIdUUIDStrategy! !

!ESDocumentId class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 14:48'!
newId
	^ self defaultIdStrategy new! !

Object subclass: #ESDocumentIdUUIDStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESDocumentIdUUIDStrategy commentStamp: 'PaulDeBruicker 4/24/2013 10:12' prior: 0!
Use this if you want to create your own UUIDs to use as ids for your documents. !

!ESDocumentIdUUIDStrategy class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 14:53'!
new
	^ UUID new! !

Object subclass: #ESDocumentIdUnixSecondsStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESDocumentIdUnixSecondsStrategy commentStamp: 'PaulDeBruicker 4/24/2013 10:12' prior: 0!
Use this if you want to create your own timestamps to use as ids for your documents. !

!ESDocumentIdUnixSecondsStrategy class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 14:50'!
new
	^ DateAndTime now asUnixTime! !

Object subclass: #ESHTTPClient
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

ESHTTPClient class
	instanceVariableNames: 'default'!

!ESHTTPClient commentStamp: 'PaulDeBruicker 4/24/2013 10:11' prior: 0!
This class only exists because I'm going to port the package to Squeak and as far as I know Squeak doesn't use Zinc but instead uses WebClient and somebody will have to change all the HTTP client stuff!

ESHTTPClient class
	instanceVariableNames: 'default'!

!ESHTTPClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:27'!
defaultHostName
	^ 'localhost'! !

!ESHTTPClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 20:34'!
defaultHttpClient
	^ ESZnClient! !

!ESHTTPClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:27'!
defaultPort
	^ 9200! !

!ESHTTPClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 20:34'!
httpClient
	^ default ifNil: [ default := self defaultHttpClient new ]! !

!ESHTTPClient methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:37'!
client
	^ client ifNil: [ client := self defaultClient new ]! !

!ESHTTPClient methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 09:59'!
defaultUrl
	self subclassResponsibility! !

!ESHTTPClient methodsFor: 'http-method' stamp: 'PaulDeBruicker 4/24/2013 10:09'!
delete: aZnUrl 
^	self client delete: aZnUrl url! !

!ESHTTPClient methodsFor: 'http-method' stamp: 'PaulDeBruicker 4/24/2013 10:07'!
get: aUrl
	^ self client get: aUrl url! !

!ESHTTPClient methodsFor: 'http-method' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
get: aUrl data: aByteString
	^ self client get: aUrl url contents: aByteString! !

!ESHTTPClient methodsFor: 'http-method' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
head: aUrl
	^ self client head: aUrl url! !

!ESHTTPClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:26'!
hostName
	^ self class defaultHostName! !

!ESHTTPClient methodsFor: 'testing' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
indexExistsAt: aUrl
	^ (self client headResponseStatusFor: aUrl url) = 200! !

!ESHTTPClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:26'!
port
	^ self class defaultPort! !

!ESHTTPClient methodsFor: 'http-method' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
post: aUrl data: aByteString
	^ self client post: aUrl url contents: aByteString! !

!ESHTTPClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
put: url data: someData
	^ self client put: url url contents: someData! !

!ESHTTPClient methodsFor: 'testing' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
typeExistsAt: aUrl
	^ (self client headResponseStatusFor: aUrl url) = 200! !

!ESHTTPClient methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 09:55'!
url
	^ self defaultUrl new! !

ESHTTPClient subclass: #ESZnClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESZnClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:00'!
baseUrl
	^ self url
		host: self hostName;
		port: self port;
		yourself! !

!ESZnClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:37'!
defaultClient
	^ ZnClient! !

!ESZnClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 09:59'!
defaultUrl
	^ ESZnUrl! !

Object subclass: #ESObject
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

ESObject subclass: #ESAnalysis
	instanceVariableNames: 'analyzers tokenizers filters charFilters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESAnalysis commentStamp: 'PaulDeBruicker 5/6/2013 12:59' prior: 0!
http://www.elasticsearch.org/guide/reference/index-modules/analysis/!

!ESAnalysis methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:00'!
addAnalyzer: anESAnalyzer
	self analyzers add: anESAnalyzer! !

!ESAnalysis methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:36'!
addCharFilter: aCharFilter
	self charFilters add: aCharFilter! !

!ESAnalysis methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 15:43'!
addFilter: anESAnalyzer
	self filters add: anESAnalyzer! !

!ESAnalysis methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:01'!
addTokenizer: anESAnalyzer
	self tokenizers add: anESAnalyzer! !

!ESAnalysis methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 13:00'!
analyzers
	^ analyzers! !

!ESAnalysis methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 13:00'!
analyzers: anObject
	analyzers := anObject! !

!ESAnalysis methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 13:35'!
charFilters
	^ charFilters! !

!ESAnalysis methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 13:35'!
charFilters: anObject
	charFilters := anObject! !

!ESAnalysis methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 13:00'!
filters
	^ filters! !

!ESAnalysis methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 13:00'!
filters: anObject
	filters := anObject! !

!ESAnalysis methodsFor: 'testing' stamp: 'PaulDeBruicker 5/6/2013 15:30'!
hasAnalyzers
	^ self analyzers notEmpty! !

!ESAnalysis methodsFor: 'testing' stamp: 'PaulDeBruicker 5/6/2013 15:29'!
hasCharFilter
	^ self charFilters notEmpty! !

!ESAnalysis methodsFor: 'testing' stamp: 'PaulDeBruicker 5/6/2013 15:30'!
hasFilter
	^ self filters notEmpty! !

!ESAnalysis methodsFor: 'testing' stamp: 'PaulDeBruicker 5/6/2013 15:30'!
hasTokenizer
	^ self tokenizers notEmpty! !

!ESAnalysis methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 5/6/2013 13:36'!
initialize
	super initialize.
	analyzers := Set new.
	tokenizers := Set new.
	filters := Set new.
	charFilters := Set new! !

!ESAnalysis methodsFor: 'json' stamp: 'PaulDeBruicker 5/6/2013 16:41'!
jsonContent
	| d1 |
	d1 := Dictionary new.
	self hasAnalyzers
		ifTrue: [ d1 at: 'analyzer' put: (self jsonStringFromCollection: self analyzers) ].
	self hasTokenizer
		ifTrue: [ d1 at: 'tokenizer' put: (self jsonStringFromCollection: self tokenizers) ].
	self hasFilter
		ifTrue: [ d1 at: 'filter' put: (self jsonStringFromCollection: self filters) ].
	self hasCharFilter
		ifTrue: [ d1 at: 'char_filter' put: (self jsonStringFromCollection: self charFilters) ].
	^ d1! !

!ESAnalysis methodsFor: 'json' stamp: 'PaulDeBruicker 5/6/2013 16:43'!
jsonStringFromCollection: aSet
	| d1 |
	d1 := Dictionary new.
	aSet do: [ :each | d1 at: each name put: each jsonContent ].
	^ d1! !

!ESAnalysis methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 13:00'!
tokenizers
	^ tokenizers! !

!ESAnalysis methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 13:00'!
tokenizers: anObject
	tokenizers := anObject! !

ESObject subclass: #ESDocument
	instanceVariableNames: 'id version index type content created modified parents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESDocument class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 4/22/2013 17:25'!
fromJson: aJsonObject 
	|newDocument|
	newDocument :=self new.
	newDocument id: (aJsonObject at:'_id');
	type: (aJsonObject at:'_type');
	version: (aJsonObject at:'_version');
	content:(aJsonObject at:'_source') asDictionary.
	^newDocument ! !

!ESDocument class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 4/22/2013 17:32'!
fromJson: aJsonObject inIndex: anESIndex
	^ self new parseContentFromJson: aJsonObject fromIndex: anESIndex! !

!ESDocument class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/22/2013 15:02'!
ofType: aType withContent: aDictionaryOfDocumentContent
	^ self new
		type: aType;
		content: aDictionaryOfDocumentContent;
		yourself! !

!ESDocument class methodsFor: 'testing' stamp: 'PaulDeBruicker 4/22/2013 15:14'!
setIdInClient
	^false! !

!ESDocument class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/22/2013 15:01'!
withContent: aDictionaryOfDocumentContent
	^ self new
		content: aDictionaryOfDocumentContent;
		yourself! !

!ESDocument methodsFor: 'comparing' stamp: 'PaulDeBruicker 4/22/2013 17:16'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ content = anObject content and: [ id = anObject id1 ]! !

!ESDocument methodsFor: 'indexing' stamp: 'PaulDeBruicker 4/23/2013 15:02'!
addToIndex: anESIndex
	| response json |
	self index: anESIndex.
	response := self hasId
		ifTrue: [ self httpClient put: self urlForIndexing data: self messageJsonContent ]
		ifFalse: [ self httpClient post: self urlForIndexing data: self messageJsonContent ].
	json := self parseJsonFromString: response.
	self
		ifResponse: json
		isNotErrorThenDo: [ :someJson | 
			(someJson at: 'ok')
				ifTrue: [ 
					self id: (someJson at: '_id').
					self version: (someJson at: '_version') asNumber ] ]! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 15:14'!
content
	
	^ content! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:28'!
content: aDictionary
	content := aDictionary.
	self updateModifiedTime! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:30'!
created
	^ created! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:38'!
created: aDateAndTime 
	
	created := aDateAndTime! !

!ESDocument methodsFor: 'testing' stamp: 'PaulDeBruicker 4/23/2013 17:37'!
hasId
	^ self id notEmpty! !

!ESDocument methodsFor: 'testing' stamp: 'PaulDeBruicker 4/23/2013 14:46'!
hasVersion
	^ self version notNil! !

!ESDocument methodsFor: 'comparing' stamp: 'PaulDeBruicker 4/22/2013 17:16'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ content hash bitXor: id hash! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 15:12'!
id
	
	 id isNil ifTrue: [self setId] .
	
	^id! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:16'!
id1
	^ id! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:11'!
id: aByteString 
	
	id := aByteString! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:00'!
index
	
	^ index! !

!ESDocument methodsFor: 'ids' stamp: 'PaulDeBruicker 4/22/2013 16:41'!
index: anIndex
	index := anIndex! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:36'!
initialize
	super initialize.
	created := DateAndTime now.
	self updateModifiedTime.
	content := Dictionary new! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 15:03'!
messageJsonContent
	"self content at: 'created' put: self created.
	self content at: 'modified' put: self modified."

	^ self content asJsonString! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:30'!
modified
	^ modified! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:37'!
modified: aDateAndTime 
	
	modified := aDateAndTime! !

!ESDocument methodsFor: 'ids' stamp: 'PaulDeBruicker 4/23/2013 14:54'!
newId
	^ ESDocumentId newId! !

!ESDocument methodsFor: 'parsing' stamp: 'PaulDeBruicker 4/22/2013 17:40'!
parseContentFromJson: aJsonObject fromIndex: anESIndex
	| data |
	self
		id: (aJsonObject at: '_id');
		index: anESIndex;
		type: (aJsonObject at: '_type');
		version: (aJsonObject at: '_version').
	(aJsonObject at: '_source') asDictionary
		keysAndValuesDo: [ :selector :value | 
			| newValue |
			newValue := value.
			(selector = 'created' or: [ selector = 'modified' ])
				ifTrue: [ 
					newValue := DateAndTime fromString: value.
					self perform: (selector , ':') asSymbol withArguments: (Array with: newValue) ].
			self content at: selector put: newValue ]! !

!ESDocument methodsFor: 'ids' stamp: 'PaulDeBruicker 4/22/2013 15:17'!
setId
	id := self setIdInClient
		ifTrue: [ self newId ]
		ifFalse: [ String new ]! !

!ESDocument methodsFor: 'testing' stamp: 'PaulDeBruicker 4/22/2013 15:14'!
setIdInClient
	^self class setIdInClient ! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 15:11'!
type
	
	^ type ifNil:['noType']! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:25'!
type: aByteString 
	
	type := aByteString! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:29'!
updateModifiedTime
	modified := DateAndTime now! !

!ESDocument methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 10:04'!
urlForIndexing
	^ self baseUrl
		addToPath: self index name;
		addToPath: self type;
		addToPath: self id! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 14:46'!
version
	^ version! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:11'!
version: aSmallInteger 
	
	version := aSmallInteger! !

ESObject subclass: #ESIndex
	instanceVariableNames: 'shards replicas analysis mapping type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESIndex class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 20:31'!
createIndex: anIndexName
	^ self new createIndexNamed: anIndexName! !

!ESIndex class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:35'!
deleteIndex: anIndexName
	^ self new deleteIndexNamed: anIndexName! !

!ESIndex class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 13:43'!
indexNamed: aName
	^ self new
		name: aName;
		yourself! !

!ESIndex methodsFor: 'documents' stamp: 'PaulDeBruicker 4/23/2013 17:28'!
addDocument: anESDocument
	anESDocument addToIndex: self! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 14:21'!
analysis
	^ analysis! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 14:21'!
analysis: anObject
	analysis := anObject! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 5/7/2013 21:30'!
create
	| response |
	response := self parseJsonFromString: (self httpClient post: self url data: self indexCreationJsonSettings).

	self ifResponse: response isNotErrorThenDo: [ :someJson | nil ]! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 5/6/2013 13:53'!
createIndexNamed: aName
	self name: aName.
	self create! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 5/7/2013 16:57'!
delete
	self indexExists
		ifTrue: [ self deleteIndexNamed: self name ]! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 4/23/2013 15:10'!
deleteIndexNamed: aName
	^ aName notEmpty
		ifTrue: [ 
			| response |
			self name: aName.
			response := self parseJsonFromString: (self httpClient delete: self url).
			self ifResponse: response isNotErrorThenDo: [ :someJson | nil ] ]
		ifFalse: [ Error signal: 'you are trying to delete all the indicies' ]! !

!ESIndex methodsFor: 'actions' stamp: 'PaulDeBruicker 4/23/2013 17:33'!
ensureExistence
	self indexExists
		ifFalse: [ self createIndexNamed: self name ]! !

!ESIndex methodsFor: 'documents' stamp: 'PaulDeBruicker 4/22/2013 17:26'!
getDocument: anESDocument
	| response |
	response := self parseJsonFromString: (self httpClient get: (self urlToGetDocument: anESDocument)).
	^ ESDocument fromJson: response inIndex: self! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 4/24/2013 10:04'!
getSettings
	| settings |
	settings := self parseJsonFromString: (self httpClient get: (self url addToPath: '_settings')).
	shards := (((settings at: self name) at: 'settings') at: 'index.number_of_shards') asNumber.
	replicas := (((settings at: self name) at: 'settings') at: 'index.number_of_replicas') asNumber! !

!ESIndex methodsFor: 'testing' stamp: 'PaulDeBruicker 5/6/2013 15:44'!
hasAnalysis
	^self analysis notNil! !

!ESIndex methodsFor: 'testing' stamp: 'PaulDeBruicker 5/6/2013 15:24'!
hasMapping
	^ self mapping notNil! !

!ESIndex methodsFor: 'testing' stamp: 'PaulDeBruicker 5/6/2013 15:25'!
hasNotDefaultValuesForShardsAndReplicas
	^ self shards ~= 5 or: [ self replicas ~= 1 ]! !

!ESIndex methodsFor: 'testing' stamp: 'PaulDeBruicker 5/6/2013 15:25'!
hasSettings
	^ self hasAnalysis or: [ self hasNotDefaultValuesForShardsAndReplicas ]! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 5/7/2013 21:53'!
indexCreationJsonSettings
	| d1 |
	d1 := Dictionary new.
	self hasSettings
		ifTrue: [ d1 at: 'settings' put: self settingsJsonContent ].
	self hasMapping
		ifTrue: [ d1 at: 'mappings' put: self mapping jsonContent ].
	^ d1 asJsonString! !

!ESIndex methodsFor: 'testing' stamp: 'PaulDeBruicker 4/23/2013 13:40'!
indexExists
	^ self httpClient indexExistsAt: self url! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 5/6/2013 15:24'!
indexSettings
	^ String
		streamContents: [ :s | 
			s nextPut: ${.
			self hasMapping
				ifTrue: [ s nextPutAll: self mapping asJsonString ].
			self hasSettings
				ifTrue: [ 
					self nextPutAll: self shardsAndReplicaSettings asJson.
					self hasAnalysis
						ifTrue: [ s nextPutAll: self analysis asJsonString ] ].
			s nextPut: $} ]! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 5/6/2013 13:50'!
initialize
	super initialize.
	shards := 5.
	replicas := 1! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 14:20'!
mapping
	^ mapping! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 14:20'!
mapping: anObject
	mapping := anObject! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
replicas
	^ replicas! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
replicas: anObject
	replicas := anObject! !

!ESIndex methodsFor: 'search' stamp: 'PaulDeBruicker 4/22/2013 21:22'!
searchFor: aQuery
	^ self httpClient get: aQuery searchUrl! !

!ESIndex methodsFor: 'urls' stamp: 'PaulDeBruicker 5/1/2013 08:39'!
searchUrl
	^ self searchUrlForType: self type! !

!ESIndex methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 10:04'!
searchUrlForType: aType
	| url |
	url := self url.
	aType notEmpty
		ifTrue: [ url addToPath: aType ].
	url addToPath: '_search'.
	^ url! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 5/6/2013 16:57'!
settingsJson
	| dict |
	dict := Dictionary new.
	dict at: 'shards' put: self shards.
	dict at: 'replicas' put: self replicas.
	dict at: 'analysis' put: self analysis jsonContent.
	^ ('settings' -> dict) asJsonString! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 5/6/2013 17:00'!
settingsJsonContent
	| dict |
	dict := Dictionary new.
	dict at: 'shards' put: self shards.
	dict at: 'replicas' put: self replicas.
	self hasAnalysis
		ifTrue: [ dict at: 'analysis' put: self analysis jsonContent ].
	^ dict! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
shards
	^ shards! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
shards: anObject
	shards := anObject! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 5/6/2013 13:55'!
shardsAndReplicaSettings
	^ (self shards = 1 and: [ self replicas = 1 ])
		ifTrue: [ String new	"use the defaults" ]
		ifFalse: [ 
			| dict |
			dict := Dictionary new.
			dict at: 'shards' put: self shards.
			dict at: 'replicas' put: self replicas.
			'settings' -> dict ]! !

!ESIndex methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 10:04'!
statusUrl
	^ self baseUrl addToPath: '_status'! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/1/2013 08:39'!
type
	^type ifNil:['']! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/1/2013 08:39'!
type: aByteString 
	type:=aByteString ! !

!ESIndex methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 10:05'!
url
	^ self baseUrl addToPath: self name! !

!ESIndex methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 10:05'!
urlToGetDocument: anESDocument
	^ self baseUrl
		addToPath: self name;
		addToPath: anESDocument type;
		addToPath: anESDocument id! !

ESObject subclass: #ESMapping
	instanceVariableNames: 'analysis properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESMapping methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 15:14'!
addMappingProperty: aMappingProperty
	self properties add: aMappingProperty! !

!ESMapping methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 15:13'!
analysis
	^ analysis! !

!ESMapping methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 15:13'!
analysis: anObject
	analysis := anObject! !

!ESMapping methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/7/2013 21:16'!
asJsonString
	| d1 |
	d1 := Dictionary new.
	d1 at: 'mappings' put: self jsonContent.
	^ d1 asJsonString! !

!ESMapping methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 17:01'!
jsonContent
	| d1 |
	d1 := Dictionary new.
	self properties do: [ :each | d1 at: each name put: each jsonContent ].
	^ d1! !

!ESMapping methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 16:26'!
properties
	^ properties ifNil: [ properties := OrderedCollection new ]! !

!ESMapping methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 15:13'!
properties: anObject
	properties := anObject! !

ESObject subclass: #ESMappingProperties
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESMappingProperties methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 14:58'!
addProperty: aProperty
	self properties add: aProperty! !

!ESMappingProperties methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 14:59'!
initialize
	super initialize.
	properties := OrderedCollection new! !

!ESMappingProperties methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 16:28'!
jsonContent
	| d1 d2 |
	d1 := Dictionary new.
	self properties do: [ :each | d1 at: each name put: each jsonContent ].
	d2 := Dictionary new.
	d2 at: 'properties' put: d1.
	^ d2! !

!ESMappingProperties methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 14:58'!
properties
	^ properties! !

!ESMappingProperties methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 14:58'!
properties: anObject
	properties := anObject! !

ESObject subclass: #ESMappingProperty
	instanceVariableNames: 'modifiers type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

ESMappingProperty subclass: #ESBinaryMappingProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESBinaryMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:49'!
type
	^ 'binary'! !

ESMappingProperty subclass: #ESBooleanMappingProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESBooleanMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:49'!
type
	^ 'boolean'! !

ESMappingProperty subclass: #ESDateMappingProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESDateMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:45'!
format: aString
	self modifiers at: 'format' put: aString! !

!ESDateMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:49'!
type
	^ 'date'! !

!ESMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:44'!
boost: aString
	self modifiers at: 'boost' put: aString! !

!ESMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:46'!
ignoreMalformed: aString
	self modifiers at: 'ignore_malformed' put: aString! !

!ESMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:44'!
includeInAll: aString
	self modifiers at: 'include_in_all' put: aString! !

!ESMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:24'!
index: aString
	"Set to analyzed for the field to be indexed and searchable after being broken down into token using an analyzer. not_analyzed means that its still searchable, but does not go through any analysis process or broken down into tokens. no means that it won’t be searchable at all (as an individual field; it may still be included in _all). Defaults to analyzed."

	self modifiers at: 'index' put: aString! !

!ESMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:23'!
indexName: aName
	self modifiers at: 'index_name' put: aName! !

!ESMappingProperty methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 15:42'!
initialize
	super initialize.
	modifiers := Dictionary new! !

!ESMappingProperty methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 17:05'!
jsonContent
	| d1 |
	d1 := self modifiers copy.
	d1 at: 'type' put: self type.
	^ d1! !

!ESMappingProperty methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/6/2013 15:41'!
modifiers
	
	^ modifiers! !

!ESMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:43'!
nullValue: aString
	self modifiers at: 'null_value' put: aString! !

!ESMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:46'!
precisionStep: aString
	self modifiers at: 'precision_step' put: aString! !

!ESMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:24'!
store: yesOrNo
	self modifiers at: 'store' put: yesOrNo! !

!ESMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 15:00'!
type
	^ type! !

!ESMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 15:00'!
type: aType
	type := aType! !

ESMappingProperty subclass: #ESMultiFieldMappingProperty
	instanceVariableNames: 'includeDefaultInAll fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESMultiFieldMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/10/2013 06:46'!
addDefaultField: aMappingProperty
	self fields add: aMappingProperty.
	self name: aMappingProperty name! !

!ESMultiFieldMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/10/2013 06:46'!
addField: aMappingProperty
	self fields add: aMappingProperty.
	self fields isEmpty
		ifTrue: [ self name: aMappingProperty name ]! !

!ESMultiFieldMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/10/2013 06:46'!
addSecondaryField: aMappingProperty
	self fields add: aMappingProperty! !

!ESMultiFieldMappingProperty methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/10/2013 06:52'!
fields
	
	^ fields! !

!ESMultiFieldMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/9/2013 16:35'!
includeDefaultInAll: aBoolean
	includeDefaultInAll := aBoolean! !

!ESMultiFieldMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/9/2013 16:35'!
initialize
	super initialize.
	fields := OrderedCollection new.
	includeDefaultInAll := true! !

!ESMultiFieldMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/10/2013 06:48'!
jsonContent
	| d1 d2 |
	d1 := self modifiers copy.
	d1 at: 'type' put: self type.
	d2 := Dictionary new.
	self fields do: [ :each | d2 at: each name put: each jsonContent ].
	d1 at: 'fields' put: d2.
	^ d1! !

!ESMultiFieldMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/9/2013 16:30'!
path: aName
	self modifiers at: 'path' put: aName! !

!ESMultiFieldMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/9/2013 16:32'!
type
	^ 'multi_field'! !

ESMappingProperty subclass: #ESNumberMappingProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESNumberMappingProperty methodsFor: 'convenience' stamp: 'PaulDeBruicker 5/6/2013 14:47'!
beByte
	self type: 'byte'! !

!ESNumberMappingProperty methodsFor: 'convenience' stamp: 'PaulDeBruicker 5/6/2013 14:46'!
beDouble
	self type: 'double'! !

!ESNumberMappingProperty methodsFor: 'convenience' stamp: 'PaulDeBruicker 5/6/2013 14:46'!
beFloat
	self type: 'float'! !

!ESNumberMappingProperty methodsFor: 'convenience' stamp: 'PaulDeBruicker 5/6/2013 14:47'!
beInteger
	self type: 'integer'! !

!ESNumberMappingProperty methodsFor: 'convenience' stamp: 'PaulDeBruicker 5/6/2013 14:47'!
beLong
	self type: 'long'! !

!ESNumberMappingProperty methodsFor: 'convenience' stamp: 'PaulDeBruicker 5/6/2013 14:47'!
beShort
	self type: 'short'! !

ESMappingProperty subclass: #ESStringMappingProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESStringMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:31'!
analyzer: aString
	self modifiers at: 'analyzer' put: aString! !

!ESStringMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:32'!
ignoreAbove: aString
	self modifiers at: 'ignore_above' put: aString! !

!ESStringMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:31'!
indexAnalyzer: aString
	self modifiers at: 'index_analyzer' put: aString! !

!ESStringMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:30'!
indexOptions: aString
	self modifiers at: 'index_options' put: aString! !

!ESStringMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:41'!
jsonStringContents
	| d1 |
	d1 := Dictionary new.
	d1 at: 'type' put: self type.
	self modifiers keysAndValuesDo: [ :key :value | d1 at: key put: value ].
	^ d1! !

!ESStringMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:30'!
omitNorms: aString
	self modifiers at: 'omit_norms' put: aString! !

!ESStringMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:30'!
omitTermFreqAndPositions: aString
	self modifiers at: 'omit_term_freq_and_positions' put: aString! !

!ESStringMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:32'!
positionOffsetGap: aString
	self modifiers at: 'position_offset_gap' put: aString! !

!ESStringMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:31'!
searchAnalyzer: aString
	self modifiers at: 'search_analyzer' put: aString! !

!ESStringMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:29'!
termVector: aString
	self modifiers at: 'term_vector' put: aString! !

!ESStringMappingProperty methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/6/2013 14:40'!
type
	^ 'string'! !

!ESObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:23'!
baseUrl
	^ self httpClient baseUrl! !

!ESObject methodsFor: 'json' stamp: 'PaulDeBruicker 4/23/2013 15:07'!
errorMessageFor: aJsonObject 
^	aJsonObject at:'error'! !

!ESObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 13:40'!
httpClient
	^ ESHTTPClient httpClient! !

!ESObject methodsFor: 'json' stamp: 'PaulDeBruicker 4/23/2013 15:03'!
ifResponse: someJson isNotErrorThenDo: aBlock
	(self responseIsError: someJson)
		ifTrue: [ Error signal: (self errorMessageFor: someJson) ]
		ifFalse: [ aBlock value: someJson ]! !

!ESObject methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
name
	^ name
! !

!ESObject methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
name: anObject
	name := anObject! !

!ESObject methodsFor: 'json' stamp: 'PaulDeBruicker 4/22/2013 14:31'!
parseJsonFromString: aString
	^ Json readFrom: aString readStream! !

!ESObject methodsFor: 'json' stamp: 'PaulDeBruicker 4/23/2013 14:59'!
responseIsError: someJson
	^ (someJson at: 'error') notNil! !

ESObject subclass: #ESSearch
	instanceVariableNames: 'index queries results'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESSearch commentStamp: 'PaulDeBruicker 4/24/2013 10:18' prior: 0!
Basic implementation of searching using the QueryDSL.  Right now it only searches for query strings and does not implement any of the other  refinements mentioned here:

http://www.elasticsearch.org/guide/reference/query-dsl/!

ESSearch subclass: #ESAPISearch
	instanceVariableNames: 'uriParameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESAPISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 5/8/2013 10:28'!
initialize
	super initialize.
	uriParameters := Dictionary new! !

!ESAPISearch methodsFor: 'urls' stamp: 'PaulDeBruicker 5/8/2013 10:36'!
queryUrl
	| url |
	url := self searchUrl.
	self uriParameters keysAndValuesDo: [ :queryKey :queryValue | url queryAt: queryKey put: queryValue ].
	^ url! !

!ESAPISearch methodsFor: 'actions' stamp: 'PaulDeBruicker 5/8/2013 10:35'!
search
	| response |
	response := self parseJsonFromString: (self httpClient get: self queryUrl).
	self ifResponse: response isNotErrorThenDo: [ :someJson | self setResultsFrom: someJson ]! !

!ESAPISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 5/8/2013 10:17'!
searchFrom: aNumber
	self uriParameters at: 'search_from' put: aNumber! !

!ESAPISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 5/8/2013 10:21'!
searchIndices: anArrayOfIndexNames
	self uriParameters at: 'search_indices' put: anArrayOfIndexNames asCommaString! !

!ESAPISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 5/8/2013 10:17'!
searchScroll: aNumber
	self uriParameters at: 'search_scroll' put: aNumber! !

!ESAPISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 5/8/2013 10:17'!
searchSize: aNumber
	self uriParameters at: 'search_size' put: aNumber! !

!ESAPISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 5/8/2013 10:15'!
searchType: anObject
	"The type of the search operation to perform. Can be dfs_query_then_fetch, dfs_query_and_fetch, query_then_fetch, query_and_fetch, count, scan. Defaults to query_then_fetch. See Search Type for more details on the different types of search that can be performed."

	self uriParameters at: 'search_type' put: anObject! !

!ESAPISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 5/8/2013 10:21'!
searchTypes: anArrayOfTypeNames
	self uriParameters at: 'search_types' put: anArrayOfTypeNames asCommaString! !

!ESAPISearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/8/2013 10:18'!
searchUrl
	^ self index searchUrl! !

!ESAPISearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/8/2013 10:15'!
uriParameters
	
	^ uriParameters! !

ESAPISearch subclass: #ESMoreLikeThisAPISearch
	instanceVariableNames: 'docId docType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESMoreLikeThisAPISearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/8/2013 10:24'!
docId
	^ docId! !

!ESMoreLikeThisAPISearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/8/2013 10:24'!
docId: anObject
	docId := anObject! !

!ESMoreLikeThisAPISearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/8/2013 10:24'!
docType
	^ docType! !

!ESMoreLikeThisAPISearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/8/2013 10:24'!
docType: anObject
	docType := anObject! !

!ESMoreLikeThisAPISearch methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/8/2013 10:20'!
mltFields: anArrayOfSearchFields
	self uriParameters at: 'mlt_fields' put: anArrayOfSearchFields asCommaString! !

!ESMoreLikeThisAPISearch methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/8/2013 10:37'!
searchUrl
	| url |
	url := self index url.
	url
		addToPath: self docType;
		addToPath: self docId asString;
		addToPath: '_mlt'.
	^ url! !

ESAPISearch subclass: #ESURISearch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESURISearch commentStamp: 'PaulDeBruicker 4/24/2013 10:17' prior: 0!
To search you need to specify an index you wish to search and then some search criteria.  You can refine the search by 'type' which limits elasticsearch to only search for documents of the specified type.  Each of the 'parameters' are described here:

http://www.elasticsearch.org/guide/reference/api/search/uri-request/!

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:44'!
analyzeWildcard: anObject
	"Should wildcard and prefix queries be analyzed or not. Defaults to false."

	self uriParameters at: 'analyze_wildcard' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:44'!
analyzer: anObject
	"The analyzer name to be used when analyzing the query string."

	self uriParameters at: 'analyzer' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:45'!
defaultField: anObject
	"The default field to use when no field prefix is defined within the query."

	self uriParameters at: 'df' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:45'!
defaultOperator: anObject
	"The default operator to be used, can be AND or OR. Defaults to OR."

	self uriParameters at: 'default_operator' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:45'!
explain: anObject
	"For each hit, contain an explanation of how scoring of the hits was computed."

	self uriParameters at: 'explain' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:45'!
fields: anObject
	"The selective fields of the document to return for each hit (either retrieved from the index if stored, or from the _source if not), comma delimited. Defaults to the internal _source field. Not specifying any value will cause no fields to return."

	self uriParameters at: 'fields' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:46'!
from: anObject
	"The starting from index of the hits to return. Defaults to 0."

	self uriParameters at: 'from' put: anObject! !

!ESURISearch methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 5/8/2013 10:28'!
initialize
	super initialize.
	uriParameters at: 'q' put: 'no query'! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:47'!
lowercaseExpandedTerms: anObject
	"Should terms be automatically lowercased or not. Defaults to true."

	self uriParameters at: 'lowercase_expanded_terms' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:44'!
queryString: aString
	"The query string (maps to the query_string query, see Query String Query for more details)."

	self uriParameters at: 'q' put: aString! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:46'!
size: anObject
	"The number of hits to return. Defaults to 10."

	self uriParameters at: 'size' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:46'!
sort: anObject
	"Sorting to perform. Can either be in the form of fieldName, or fieldName:asc/fieldName:desc. The fieldName can either be an actual field within the document, or the special _score name to indicate sorting based on scores. There can be several sort parameters (order is important)."

	self uriParameters at: 'sort' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:46'!
timeout: anObject
	"A search timeout, bounding the search request to be executed within the specified time value and bail with the hits accumulated up to that point when expired. Defaults to no timeout."

	self uriParameters at: 'timeout' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:46'!
trackScores: anObject
	"When sorting, set to true in order to still track scores and return them as part of each hit."

	self uriParameters at: 'track_scores' put: anObject! !

!ESSearch class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 11:17'!
index: anESIndex
	^ self new
		index: anESIndex;
		yourself! !

!ESSearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/27/2013 09:05'!
addQuery: aQuery
	self queries add: aQuery! !

!ESSearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 11:29'!
index
	^ index! !

!ESSearch methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 11:29'!
index: anESIndex
	index := anESIndex! !

!ESSearch methodsFor: 'actions' stamp: 'PaulDeBruicker 4/29/2013 07:15'!
jsonQuery
	^ String
		streamContents: [ :s | 
			s nextPut: ${.
			self queries
				doWithIndex: [ :eachQuery :idx | 
					s nextPutAll: eachQuery asJsonString.
					idx = self queries size
						ifFalse: [ s nextPutAll: ', ' ] ].
			s nextPut: $} ]! !

!ESSearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/27/2013 09:05'!
queries
	^ queries ifNil: [ queries := OrderedCollection new ]! !

!ESSearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 11:29'!
results
	^ results! !

!ESSearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 11:29'!
results: anObject
	results := anObject! !

!ESSearch methodsFor: 'actions' stamp: 'PaulDeBruicker 5/7/2013 11:19'!
search
	| response |
	response := self parseJsonFromString: (self httpClient get: self index searchUrl data: self jsonQuery).

	self ifResponse: response isNotErrorThenDo: [ :someJson | self setResultsFrom: someJson ]! !

!ESSearch methodsFor: 'actions' stamp: 'PaulDeBruicker 4/23/2013 13:29'!
setResultsFrom: response
	results := ((response at: 'hits') at: 'hits')
		collect: [ :eachJsonDocument | ESDocument fromJson: eachJsonDocument inIndex: self index ]! !

ESObject subclass: #ESType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

Object subclass: #ESQuery
	instanceVariableNames: 'query field modifiers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core-QueryDSL'!

!ESQuery commentStamp: 'PaulDeBruicker 4/24/2013 10:16' prior: 0!
Elasticesearch uses a big QueryDSL to fine tune searching.  Its not implemented in this client at all yet.  !

ESQuery subclass: #ESLikeThisQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core-QueryDSL'!

ESLikeThisQuery subclass: #ESFuzzyLikeThisQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core-QueryDSL'!

!ESFuzzyLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:40'!
ignoreTermFrequency: aBoolean
	^ self modifiers at: 'ignore_tf' put: aBoolean! !

!ESFuzzyLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:41'!
minimumSimilarity: aNumber
	^ self modifiers at: 'min_similarity' put: aNumber! !

!ESFuzzyLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:40'!
minimumSimilaryity: aNumber
	^ self modifiers at: 'min_similarity' put: aNumber! !

!ESFuzzyLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:43'!
queryName
	^ 'fuzzy_like_this'! !

!ESLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:45'!
fields: aFieldOrArrayOfFields
	^ self modifiers at: 'fields' put: aFieldOrArrayOfFields! !

!ESLikeThisQuery methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/26/2013 09:02'!
jsonStringContents
	| d1 d2 |
	d1 := modifiers copy.
	d1 at: 'like_text' put: self query.
	d2 := Dictionary new.
	d2 at: self queryName put: d1.
	^ d2! !

!ESLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:46'!
maximumQueryTerms: aNumber
	^ self modifiers at: 'max_query_terms' put: aNumber! !

ESLikeThisQuery subclass: #ESMoreLikeThisQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core-QueryDSL'!

!ESMoreLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:36'!
boostTerms: aNumber
	^ self modifiers at: 'boost_terms' put: aNumber! !

!ESMoreLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:35'!
maximumDocumentFrequency: aNumber
	^ self modifiers at: 'max_doc_freq' put: aNumber! !

!ESMoreLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:35'!
maximumWordLength: aNumber
	^ self modifiers at: 'max_word_len' put: aNumber! !

!ESMoreLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:35'!
minimumDocumentFrequency: aNumber
	^ self modifiers at: 'min_doc_freq' put: aNumber! !

!ESMoreLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:33'!
minimumTermFrequency: aNumber
	^ self modifiers at: 'min_term_freq' put: aNumber! !

!ESMoreLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:36'!
minimumWordLength: aNumber
	^ self modifiers at: 'min_word_len' put: aNumber! !

!ESMoreLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:33'!
percentTermsToMatch: aNumber
	^ self modifiers at: 'percent_terms_to_match' put: aNumber! !

!ESMoreLikeThisQuery methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/26/2013 08:42'!
queryName
	^ 'more_like_this'! !

!ESMoreLikeThisQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:34'!
stopWords: anArrayOfWords
	^ self modifiers at: 'stop_words' put: anArrayOfWords! !

ESQuery subclass: #ESMatchQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core-QueryDSL'!

!ESMatchQuery methodsFor: 'search modifiers' stamp: 'PaulDeBruicker 4/26/2013 06:48'!
boolean: aBoolean
	^ self modifiers at: 'operator' put: aBoolean! !

!ESMatchQuery methodsFor: 'search modifiers' stamp: 'PaulDeBruicker 4/26/2013 06:48'!
cutoffFrequency: aNumber
	^ self modifiers at: 'cutoff_frequency' put: aNumber! !

!ESMatchQuery methodsFor: 'search modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:07'!
fuzziness: aNumber
	^ self modifiers at: 'fuzziness' put: aNumber! !

!ESMatchQuery methodsFor: 'json' stamp: 'PaulDeBruicker 4/26/2013 09:00'!
jsonStringContents
	^ self hasModifiers
		ifTrue: [ self modifiedJson ]
		ifFalse: [ self simpleJson ]! !

!ESMatchQuery methodsFor: 'search modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:04'!
matchPhrase
	^ self modifiers at: 'type' put: 'phrase'! !

!ESMatchQuery methodsFor: 'search modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:05'!
matchPhrasePrefix
	^ self modifiers at: 'type' put: 'phrase_prefix'! !

!ESMatchQuery methodsFor: 'search modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:08'!
maxExpansions: aNumber
	^ self modifiers at: 'max_expansions' put: aNumber! !

!ESMatchQuery methodsFor: 'json' stamp: 'PaulDeBruicker 4/26/2013 09:00'!
modifiedJson
	| d1 d2 d3 |
	d1 := modifiers copy.
	d1 at: 'query' put: self query.
	d2 := Dictionary new.
	d2 at: self field put: d1.
	d3 := Dictionary new.
	d3 at: 'match' put: d2.
	^ d3! !

!ESMatchQuery methodsFor: 'json' stamp: 'PaulDeBruicker 4/26/2013 09:01'!
simpleJson
	| d1 d2 |
	d1 := Dictionary new.
	d1 at: self field put: self query.
	d2 := Dictionary new.
	d2 at: 'match' put: d1.
	^ d2! !

ESMatchQuery subclass: #ESMultiMatchQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core-QueryDSL'!

!ESMultiMatchQuery methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/10/2013 07:22'!
fields: aNumber
	^ self modifiers at: 'fields' put: aNumber! !

!ESMultiMatchQuery methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/10/2013 07:45'!
modifiedJson
	| d1 d2 d3 |
	d1 := modifiers copy.
	d1 at: 'query' put: self query.
	d2 := Dictionary new.
	d2 at: self field put: d1.
	d3 := Dictionary new.
	d3 at: 'multi_match' put: d2.
	^ d3! !

!ESMultiMatchQuery methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/10/2013 07:24'!
tieBreaker: aNumber
	^ self modifiers at: 'tie_breaker' put: aNumber! !

!ESMultiMatchQuery methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/10/2013 07:23'!
useDisMax: aBoolean
	^ self modifiers at: 'use_dis_max' put: aBoolean! !

!ESQuery methodsFor: 'search modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:36'!
analyzer: anAnalyzer
	^ self modifiers at: 'analyzer' put: anAnalyzer! !

!ESQuery methodsFor: 'testing' stamp: 'PaulDeBruicker 4/28/2013 21:02'!
asJsonString
	| d |
	d := Dictionary new.
	d at: 'query' put: self jsonStringContents.	"^ d asJsonString"
	^( 'query' -> self jsonStringContents) asJsonString ! !

!ESQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:36'!
boost: aNumber
	^ self modifiers at: 'boost' put: aNumber! !

!ESQuery methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/26/2013 06:45'!
field
	^ field ifNil: [ ^ '_all' ]! !

!ESQuery methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/26/2013 06:42'!
field: anObject
	field := anObject! !

!ESQuery methodsFor: 'testing' stamp: 'PaulDeBruicker 4/26/2013 06:45'!
hasField
	^ field notNil! !

!ESQuery methodsFor: 'testing' stamp: 'PaulDeBruicker 4/26/2013 08:11'!
hasModifiers
	^ self modifiers notEmpty! !

!ESQuery methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/26/2013 08:11'!
initialize
	super initialize.
	modifiers := Dictionary new! !

!ESQuery methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/26/2013 06:42'!
modifiers
	^ modifiers! !

!ESQuery methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/26/2013 06:42'!
modifiers: anObject
	modifiers := anObject! !

!ESQuery methodsFor: 'search modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:42'!
prefixLength: aNumber
	^ self modifiers at: 'prefix_length' put: aNumber! !

!ESQuery methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/26/2013 06:42'!
query
	^ query! !

!ESQuery methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/26/2013 06:42'!
query: anObject
	query := anObject! !

!ESQuery methodsFor: 'modifiers' stamp: 'PaulDeBruicker 4/26/2013 08:31'!
resetModifiers
	modifiers := Dictionary new! !

ESQuery subclass: #ESQueryStringQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core-QueryDSL'!

!ESQueryStringQuery class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 11:19'!
forString: aString
	^ self new
		queryString: aString;
		yourself! !

!ESQueryStringQuery methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 11:46'!
asQueryString
	^ 'q=' , self queryString! !

!ESQueryStringQuery methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/26/2013 09:02'!
jsonStringContents
	| d1 d2 |
	d1 := Dictionary new.
	d1 at: 'query' put: self queryString.
	d2 := Dictionary new.
	d2 at: 'query_string' put: d1.
	^ d2! !

!ESQueryStringQuery methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/26/2013 06:41'!
queryString
	^ self query! !

!ESQueryStringQuery methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/26/2013 06:41'!
queryString: anObject
	self query: anObject! !

ESQuery subclass: #ESSort
	instanceVariableNames: 'criteria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core-QueryDSL'!

!ESSort methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/27/2013 08:56'!
addCriteria: anESSortCriteria
	self criteria add: anESSortCriteria! !

!ESSort methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/29/2013 07:16'!
asJsonString
	"	| d1 |
	d1 := Dictionary new.
	d1 at: 'sort' put: self criteria."

	^ ('sort' -> self criteria) asJsonString! !

!ESSort methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/27/2013 08:55'!
byScore
	self criteria add: '_score'! !

!ESSort methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/27/2013 08:55'!
criteria
	^ criteria! !

!ESSort methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/27/2013 08:55'!
criteria: anObject
	criteria := anObject! !

!ESSort methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/27/2013 08:55'!
initialize
	super initialize.
	criteria := OrderedCollection new! !

ESQuery subclass: #ESSortCriteria
	instanceVariableNames: 'fieldName ascending mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core-QueryDSL'!

!ESSortCriteria methodsFor: 'json' stamp: 'PaulDeBruicker 4/27/2013 08:49'!
addModeTo: aDictionary
	self hasMode
		ifTrue: [ aDictionary at: 'mode' put: self mode ]! !

!ESSortCriteria methodsFor: 'json' stamp: 'PaulDeBruicker 4/27/2013 08:48'!
addOrderTo: aDictionary
	self hasOrder
		ifTrue: [ 
			aDictionary
				at: 'order'
				put:
					(self ascending
						ifTrue: [ 'asc' ]
						ifFalse: [ 'desc' ]) ]! !

!ESSortCriteria methodsFor: 'json' stamp: 'PaulDeBruicker 4/27/2013 08:58'!
asJsonString
	| d1 d2 |
	d1 := Dictionary new.
	self addOrderTo: d1.
	self addModeTo: d1.
	d2 := Dictionary new.
	d2 at: self fieldName put: d1.
	^ d2 asJsonString! !

!ESSortCriteria methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/27/2013 08:42'!
ascending
	^ ascending! !

!ESSortCriteria methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/27/2013 08:42'!
ascending: anObject
	ascending := anObject! !

!ESSortCriteria methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/27/2013 08:42'!
fieldName
	^ fieldName! !

!ESSortCriteria methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/27/2013 08:42'!
fieldName: anObject
	fieldName := anObject! !

!ESSortCriteria methodsFor: 'testing' stamp: 'PaulDeBruicker 4/27/2013 08:43'!
hasMode
	^ mode notNil! !

!ESSortCriteria methodsFor: 'testing' stamp: 'PaulDeBruicker 4/27/2013 08:43'!
hasOrder
	^ ascending notNil! !

!ESSortCriteria methodsFor: 'json' stamp: 'PaulDeBruicker 4/27/2013 08:54'!
jsonStringContents
	| d1 d2 |
	d1 := Dictionary new.
	self addOrderTo: d1.
	self addModeTo: d1.
	d2 := Dictionary new.
	d2 at: self fieldName put: d1.
	^ d2! !

!ESSortCriteria methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/27/2013 08:42'!
mode
	^ mode! !

!ESSortCriteria methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/27/2013 08:42'!
mode: anObject
	mode := anObject! !

!ESSortCriteria methodsFor: 'actions' stamp: 'PaulDeBruicker 4/27/2013 08:44'!
sortAscending
	self ascending: true! !

!ESSortCriteria methodsFor: 'actions' stamp: 'PaulDeBruicker 4/27/2013 08:44'!
sortDescending
	self ascending: false! !

!ESSortCriteria methodsFor: 'actions' stamp: 'PaulDeBruicker 4/27/2013 08:51'!
useAvg
	self mode: 'avg'! !

!ESSortCriteria methodsFor: 'actions' stamp: 'PaulDeBruicker 4/27/2013 08:51'!
useMax
	self mode: 'max'! !

!ESSortCriteria methodsFor: 'actions' stamp: 'PaulDeBruicker 4/27/2013 08:50'!
useMin
	self mode: 'min'! !

!ESSortCriteria methodsFor: 'actions' stamp: 'PaulDeBruicker 4/27/2013 08:51'!
useSum
	self mode: 'sum'! !

Object subclass: #ESUrl
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESUrl commentStamp: 'PaulDeBruicker 4/24/2013 10:11' prior: 0!
This class only exists because I'm going to port it to Squeak and as far as I know Squeak doesn't use Zinc but instead uses WebClient and somebody will have to change all the HTTP client stuff!

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:05'!
addToPath: aPath
	self url addPathSegment: aPath! !

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:01'!
defaultUrl
	self subclassResponsibility! !

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:01'!
host: aHostname
	self url host: aHostname! !

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:02'!
port: aHostname
	self url port: aHostname! !

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:02'!
queryAt: aKey put: aValue
	self url queryAt: aKey put: aValue! !

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:00'!
url
	^ url ifNil: [ url := self defaultUrl new ]! !

ESUrl subclass: #ESZnUrl
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESZnUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:01'!
defaultUrl
	^ ZnUrl! !
